#include <stdio.h>

// only for getch()
#include <conio.h>

const int STRLEN = 1024;

/*
//   .     
double Value_Ver_0(char* str)
{
	int i;
	//    (  )  '+'
	for (i = 0; str[i] != '\0'; i++) 
	{
		if (str[i] == '+') //  
		{
			str[i] = '\0'; //      
			//        .
			//   ,    
			return Value_Ver_0(str) + Value_Ver_0(str + i + 1);  
		}
	}
	
	//   ,   .    .
	double x = 0;
	//   str   x (   )
	for (i = 0; str[i]>='0' && str[i]<='9'; i++) x = x*10 + (str[i] - '0');
	return x;
}
*/
/*
//    . + - * /  
double Value_Ver_I(char* str)
{
	int i;
	//     .
	int a = -1, b =0;
	for (i = 0; str[i] != '\0'; i++) 
	{
		if (a+1 == i && str[i] == ' ') a = i; //   
		if (str[i] != ' ') b = i; //     
	}
	int size = b+1;
	str[size] = '\0';
	if (a >= 0) return Value_Ver_I(str + a + 1); //   ,    

	//  +  -   , .. 3-1+1 => (3-1) + (2) ,   (3) - (1+2)
	for (i = size - 1; i > 0; i--) // i > 0,   i >= 0 .. +/-       
	{
		if (str[i] == '+') 
		{
			str[i] = '\0';
			return Value_Ver_I(str) + Value_Ver_I(str + i + 1);
		}
		if (str[i] == '-') 
		{
			str[i] = '\0';
			return Value_Ver_I(str) - Value_Ver_I(str + i + 1);
		}
	}
	//  *  /   , .. 3/1*2 => (3/1) * (2) ,   (3) / (1*2)
	for (i = size - 1; i > 0; i--) // i > 0,   i >= 0 .. +/-       
	{
		if (str[i] == '*') 
		{
			str[i] = '\0';
			return Value_Ver_I(str) * Value_Ver_I(str + i + 1);
		}
		if (str[i] == '/') 
		{
			str[i] = '\0';
			return Value_Ver_I(str) / Value_Ver_I(str + i + 1);
		}
	}

	//   ,   .    .
	double x = 0;
	//   str   x
	int m = 0; //  
	i = 0;
	if (str[i] == '-') {m = 1; i++;}
	else if (str[i] == '+') {m = 0; i++;}

	//  
	for (; str[i]>='0' && str[i]<='9'; i++)
	{
		x = x*10 + (str[i] - '0');
	}
	
	//  
	if (str[i] == '.' || str[i] == ',')
	{
		i++;
		double p = 0.1;
		for (; str[i]>='0' && str[i]<='9'; i++)
		{
			x += p*(str[i] - '0');
			p /= 10;
		}
	}
	if (m) x *= -1; //  
	return x;
}
*/

const double EPS = 1e-10; //     0

//      . + - * /  .  .
double Value_Ver_II(char* str)
{
	//printf ("\"%s\"\n", str);
	int i;
	int a = -1, b =0;
	for (i = 0; str[i] != '\0'; i++) 
	{
		if (a+1 == i && str[i] == ' ') a = i;
		if (str[i] != ' ') b = i;
	}
	int size = b+1;
	str[size] = '\0';
	if (a >= 0) return Value_Ver_II(str + a + 1);

	int sk = 0; //     

	for (i = size - 1; i > 0; i--) // i > 0,   i >= 0 .. +,-       
	{
		if (str[i] == ')') {sk++; continue;}
		if (str[i] == '(') {sk--; continue;}
		if (sk == 0)
		{
			if (str[i] == '+') 
			{
				str[i] = '\0';
				return Value_Ver_II(str) + Value_Ver_II(str + i + 1);
			}
			if (str[i] == '-') 
			{
				str[i] = '\0';
				return Value_Ver_II(str) - Value_Ver_II(str + i + 1);
			}
		}
		else if (sk<0) {printf ("Error #1!!!\n"); return 0;}
	}
	if (sk - ((str[i] == '(') ? 1 : 0) != 0) {printf ("Error #2!!!\n"); return 0;}

	sk = 0;
	for (i = size - 1; i > 0; i--) // i > 0,   i >= 0 .. *,/       
	{
		if (str[i] == ')') {sk++; continue;}
		if (str[i] == '(') {sk--; continue;}
		if (sk == 0)
		{
			if (str[i] == '*') 
			{
				str[i] = '\0';
				return Value_Ver_II(str) * Value_Ver_II(str + i + 1);
			}
			if (str[i] == '/') 
			{
				str[i] = '\0';
				double x = Value_Ver_II(str + i + 1);
				//    0 (  )
				if (-EPS < x && x < EPS) {printf ("Error #6!!!\n"); return 0;}
				else return Value_Ver_II(str) / x;
			}
		}
		else if (sk<0) {printf ("Error #3!!!\n"); return 0;}
	}
	if (sk - ((str[i] == '(') ? 1 : 0) != 0) {printf ("Error #4!!!\n"); return 0;}

	if (str[0] == '(' && str[size-1] == ')') 
	{
		str[size-1] = '\0';
		return Value_Ver_II(str+1);
	}
	
	double x = 0;
	int m = 0;
	i = 0;
	if (str[i] == '-') {m = 1; i++;}
	else if (str[i] == '+') {m = 0; i++;}

	for (; str[i]>='0' && str[i]<='9'; i++)
	{
		x = x*10 + (str[i] - '0');
	}
	if (str[i] == '.' || str[i] == ',')
	{
		i++;
		double p = 0.1;
		for (; str[i]>='0' && str[i]<='9'; i++)
		{
			x += p*(str[i] - '0');
			p /= 10;
		}
	}
	if (m) x *= -1;

	//    
	if (i==0) {printf("Error #5!!!\n"); return 0;}
	if (i!=size) {printf("Error #7!!!\n"); return 0;}
	return x;
}

double Value_Math_String (const char* str)
{
	int i;
	for (i = 0; str[i] != '\0'; i++) ;
	int size = i;
	char *copy_str = new char[size+1];
	for (i = 0; i <= size; i++) copy_str[i] = str[i];
/*
#include <string.h>

...

double Value_Math_String (const char* str)
{
	char *copy_str = new char[ strlen(str) + 1 ];
	strcpy (copy_str, str);
*/
	double x = Value_Ver_II (copy_str);
	delete[] copy_str;
	return x;
}

void PrintValue(const char* str, const char* str2 = NULL)
{
	if (!str) return;
	if (str2) 
		printf ("x = %10s = %10.5f (= %s)\n", str, Value_Math_String (str), str2);
	else
		printf ("x = %10s = %10.5f\n", str, Value_Math_String (str));
}

int main(void)
{
	char str[STRLEN] = "";
	printf ("\t\t\t\tTest:\n");
	printf ("\t\t\t\t\t1) +:\n");
	PrintValue ("2+2", "4");
	printf ("\t\t\t\t\t2) -:\n");
	PrintValue ("4-2", "2");
	printf ("\t\t\t\t\t3) *:\n");
	PrintValue ("4*2", "8");
	printf ("\t\t\t\t\t4) /:\n");
	PrintValue ("4/2", "2");
	PrintValue ("4/0", "Error");
	printf ("\t\t\t\t\t5) precedence, ():\n");
	PrintValue ("2+2*3", "8");
	PrintValue ("(2+2)*3", "12");
	PrintValue ("(2+2*3", "Error");
	PrintValue ("2+2)*3", "Error");
	PrintValue ("(2+2)(3)", "Error");
	printf ("\t\t\t\t\t6) values:\n");
	PrintValue ("2", "2");
	PrintValue ("-2", "-2");
	PrintValue ("2.343", "2.343");
	PrintValue (".343", ".343");
	PrintValue ("3.", "3.");
	PrintValue ("3.4.5", "Error");
	PrintValue ("2.1-2.53", "-0.43");
	PrintValue ("-2.53+2.1", "-0.43");
	printf ("\t\t\t\t\t7) space:\n");
	PrintValue ("2 + 2", "4");
	printf ("\t\t\t\t\t8) quest:\n");
	printf ("x = ");
	gets(str);
	PrintValue (str);
	getch();
	return 0;
}